/* tests mmap */

#include <stdio.h>
#include "utilFileMem.h"

#define NUMITEMS 76
#define NUMTOSTACK 19995
#define NUMSEGMENTS 1
#define MAXSEGMENTS 3825
#define TESTMODE UFM_NEW
#define TESTDESTROY 1
#define ITERATIONS 3
#define SHOULDKEEP 1

struct stackElement
{
  double junkdata;
  int a, b, c, d, e, f, g, h, i, j, k, l, m, n;
  char stuff[300];
   int data;
   struct stackElement *next;
};

main()
  {
    char *testspace1, *testspace2, *testspace3, *testspaceRe;
    struct stackElement *firstBlock, *nextBlock, *lastBlock;
    int  i, j, result;
    char input[20];

    static int items[NUMITEMS] = {7,2,8,1,9,2,8,3,6,2,6,9,2,5,9,1,5,2,7,9,1,4,5,8,1,4,1,2,0,9,12,76,23,6,1,45,98,12,45,14,78,12,76,23,236,698,13,467,69,24,46,43,865,51,85,60,325,58,346,4563,867,432,675,56978,2346,56784,97,52143,36754,594,26,59,226,4,2,3};




    /* open the memory file */
    debugPrintFileMem();
    result = initGrowableFileMem("test.mf", TESTMODE,
NUMSEGMENTS, MAXSEGMENTS);
    if (result != 0) 
      {
        fprintf(stderr, "Cannot open file; code=%d ", result);
        perror(NULL);
        exit(0);
      }
    debugPrintFileMem();

    /* initial test of reallocation */
    testspace1 = (char *) allocFileMem(1000);
    printf("Initial size 1000: %x\n", testspace1);
    debugPrintBlocks();

    testspaceRe = (char *) reallocFileMem(testspace1, 900);
    debugPrintBlocks();

    testspace2 = (char *) allocFileMem(500);
    testspace3 = (char *) allocFileMem(300);
    debugPrintBlocks();

    testspaceRe = (char *) reallocFileMem(testspaceRe, 800);
    printf("Reallocated at 800: %x\n", testspaceRe);
    debugPrintBlocks();

    freeFileMem(testspace2);
    printf("Freed second spot of 500\n");
    debugPrintBlocks();

    /* should now be a hole allowing realloc */
    testspaceRe = (char *) reallocFileMem(testspaceRe, 1200);
    printf("Reallocated at 1200: %x\n", testspaceRe);
    debugPrintBlocks();

    testspaceRe = (char *) reallocFileMem(testspaceRe, 1300);
    printf("Reallocated at 1300: %x\n", testspaceRe);
    debugPrintBlocks();

    testspaceRe = (char *) reallocFileMem(testspaceRe, 1400);
    printf("Reallocated at 1400: %x\n", testspaceRe);
    debugPrintBlocks();

    testspaceRe = (char *) reallocFileMem(testspaceRe, 1500);
    printf("Reallocated at 1500: %x\n", testspaceRe);
    debugPrintBlocks();

    testspaceRe = (char *) reallocFileMem(testspaceRe, 1600);
    printf("Reallocated at 1600: %x\n", testspaceRe);
    debugPrintBlocks();

    for(j=ITERATIONS;j>0; j--)
      {
        if(TESTMODE == UFM_READ)
          {
            firstBlock = (struct stackElement *)getFirstBlockOfFileMem();
          }
        else
          {
            /* stack some items in the file */
            firstBlock = (struct stackElement *)allocFileMem(sizeof(struct stackElement));
            if(firstBlock == NULL)
              {
                printf("RAN OUT OF MEMORY allocating first block %d\n",i); fflush(stdout);
                exit(0);
              }
            
            firstBlock->data = -1;
            firstBlock->junkdata = 234.6;
            firstBlock->next = NULL;
            
            lastBlock = firstBlock; /* for queue only */
            
            for(i=0; i< NUMTOSTACK; i++)
              {
                if(i==10)
                  {
                    debugPrintFileMem();
                    printf("waiting at item 10, hit return: "); fgets(input, 3, stdin);
                  }
                nextBlock = (struct stackElement *)allocFileMem(sizeof(struct stackElement));
                if(nextBlock == NULL)
                  {
                    printf("ran out of memory at item %d\n",i); fflush(stdout);
                    break;
                  }
                else
                  {
                    nextBlock->data = i; /* items[i] */
                    nextBlock->junkdata = 23456.876876;
                    
                    /* code for a queue */
                    lastBlock->next = nextBlock;
                    nextBlock->next = NULL;
                    lastBlock = nextBlock; 
                    
                    /* code for a stack 
                    nextBlock->next = firstBlock;
                    firstBlock = nextBlock; */
                  }
              }
          }
        
        debugPrintFileMem();
        printf("waiting after items are allocated, hit return: ");  fgets(input, 3, stdin);

        if(TESTMODE != UFM_READ)
        {
          /* minimize the file */
          result =minimizeFileMem();
          debugPrintFileMem();
          printf("waiting after space is minimized (rc=%d), hit return: ",result);  fgets(input, 3, stdin);
                   
          /* unstack the items to verify that pointers work*/

          if (! SHOULDKEEP)
          {        
            while(firstBlock != NULL)
              {
                nextBlock = firstBlock;
                firstBlock = nextBlock->next;
                
                if(NUMTOSTACK < 200)
                  printf("..%d ", nextBlock->data); fflush(stdout);

                if(TESTMODE != UFM_READ && TESTDESTROY)
                  {
                    freeFileMem(nextBlock);
                  }
              }
          
            debugPrintFileMem();
            printf("waiting after items are freed, hit return: ");  fgets(input, 3, stdin);

            /* minimize the file */
            result =minimizeFileMem();
            debugPrintFileMem();
            printf("waiting after space is minimized (rc=%d), hit return: ",result);  fgets(input, 3,stdin);
          }
        }
      }

    terminateFileMem();    

    debugPrintFileMem();
    printf("done\n");
}
